﻿//using BookingChartTest2.Models;
using DHTMLX.Scheduler;
using DHTMLX.Scheduler.Controls;
using DHTMLX.Scheduler.Data;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace BookingChartTest2.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            var scheduler = new DHXScheduler(this);
            //scheduler.Skin = DHXScheduler.Skins.Flat;

            //scheduler.Config.first_hour = 6;
            //scheduler.Config.last_hour = 20;

            //scheduler.LoadData = true;
            //scheduler.EnableDataprocessor = true;

            //return View(scheduler);

            //var scheduler = new DHXScheduler(this);
            //scheduler.Extensions.Add(SchedulerExtensions.Extension.Multisection);

            //var timeline = new TimelineView("timeline", "y_property");
            //timeline.RenderMode = TimelineView.RenderModes.Bar;

            //var options = new object[]{
            //    new {key = 1, label = "Section #1" },
            //    new {key = 2, label = "Section #2" },
            //    new {key = 3, label = "Section #3" },
            //    new {key = 4, label = "Section #4" }
            //};
            //timeline.AddOptions(options);
            //scheduler.Views.Add(timeline);

            //var timeline = new TimelineView("timeline", "room_id");
            //timeline.RenderMode = TimelineView.RenderModes.Tree;

            //var section = timeline.AddOption(new TimelineUnit("1", "Department 1", true));//adds folder to the axis  
            //section.AddOption(new TimelineUnit("2", "Room 1"));// defines the items of the folder
            //section.AddOption(new TimelineUnit("3", "Room 2"));

            //var section2 = timeline.AddOption(new TimelineUnit("4", "Department 2", true));
            //section2.AddOption(new TimelineUnit("5", "Room 1"));
            //section2.AddOption(new TimelineUnit("6", "Room 2"));
            //scheduler.Views.Add(timeline);


            var room1 = new Room { Id=1, key=1, label="room1"};
            var room2 = new Room { Id = 2, key = 2, label = "room2" };
            var rooms = new List<Room> { room1, room2 };

            var department1 = new Department { Id = 1, Title = "dep1"};
            var department2 = new Department { Id = 2, Title = "dep2"};
            //department1.Room = room1;
            //department2.Room = room2;
            department1.Rooms.Add(room1);
            department1.Rooms.Add(room2);
            department2.Rooms.Add(room1);
            department2.Rooms.Add(room2);
            //department1.Rooms = rooms;
            //department2.Rooms = rooms;
            var departments = new List<Department> { department1, department2 };

            var timeline = new TimelineView("timeline", "room_id");
            timeline.FolderEventsAvailable = false;
            timeline.RenderMode = TimelineView.RenderModes.Tree;
            foreach (var department in departments)
            {
                TimelineUnit section = new TimelineUnit(department.Id, department.Title);// defines the header of the folder
                timeline.AddOption(section);
                section.AddOptions(department.Rooms);//'Rooms' in the name of model data table
            }
            scheduler.Views.Add(timeline);




            // Multiselect lightbox
            //scheduler.Lightbox.Add(new LightboxText("text", "Title"));

            //var multiselect = new LightboxMultiselect("y_property", "Sections");
            //multiselect.AddOptions(options);
            //scheduler.Lightbox.Add(multiselect);

            //scheduler.Lightbox.Add(new LightboxMiniCalendar("time", "Time"));


            return View(scheduler);
        }

        //public ContentResult Data()
        //{
        //    var evs = new List<object>{
        //        new { text = "First", start_date = new DateTime(2014, 8, 1), end_date = new DateTime(2014, 8, 4),  y_property = "1,3"},
        //        new { text = "Second", start_date = new DateTime(2014, 8, 3), end_date = new DateTime(2014, 8, 5), y_property = "2,4"},
        //        new { text = "Third", start_date = new DateTime(2014, 8, 2), end_date =new DateTime(2014, 8, 8),   y_property = "1"},
        //        new { text = "Fourth", start_date = new DateTime(2014, 8, 4), end_date = new DateTime(2014, 8, 5), y_property = "3"}
        //    };

        //    return Content(new SchedulerAjaxData(evs).Render());
        //}


        public class Department
        {
            public Department()
            {
                Rooms = new List<Room>();
            }

            public int Id { get; set; }
            public string Title { get; set; }
            public List<Room> Rooms { get; set; }
            //public Room Room { get; set; }
        }

        public class Room
        {
            public int Id { get; set; }
            public int key { get; set; }
            public string label { get; set; }
        }
    }
}
